/*
 * CTU Open Contest 2012
 *
 * Sample solution: Ants
 * Author: Jan Stoklasa
 */


#include <iostream>
#include <vector>
#include <algorithm>
#include <limits>
 
using namespace std;
 
const char Left = 'L';
const char Right = 'R';
 
struct Ant
{
	int x;
	char direction;
 
	Ant(int x = 0, char direction = Right)
	{
		this->x = x;
		this->direction = direction;
	}
 
	static bool lessThan(const Ant& lhs, const Ant& rhs)
	{
		return lhs.x < rhs.x;
	}
};
 
int main(int argc, char* argv[])
{
	int A, L;
	while (cin >> L >> A)
	{
		int seconds = -1;
		vector<Ant> ants(A);
		for (int i = 0; i < A; i++)
		{
			cin >> ants[i].x >> ants[i].direction;
			if (ants[i].direction == Left)
			{
				seconds = max(seconds, ants[i].x);
			}
			else
			{
				seconds = max(seconds, L - ants[i].x);
			}
		}
		sort(ants.begin(), ants.end(), Ant::lessThan);
		vector <int> antMoved(A);
		for (int i = 0; i < A; i++)
		{
			if (ants[i].direction == Left)
			{
				antMoved[i] = ants[i].x - seconds;
			}
			else
			{
				antMoved[i] = ants[i].x + seconds;
			}
		}
		sort(antMoved.begin(), antMoved.end());		
		cout << "The last ant will fall down in " << seconds << " seconds - started at ";
		int noLastAnts = 0;
		for (int i = 0; i < antMoved.size(); i++)
		{
			if (antMoved[i] == 0 || antMoved[i] == L)
			{
				if(++noLastAnts == 2)
					cout << " and ";
				else if (noLastAnts > 2)
					printf("ants: internal error - can't have more than 2 last ants.\n");
				cout << ants[i].x;
			}
		}
		cout << "." << endl;
	}
	return 0;
}

