/*
 * CTU Open Contest 2012
 *
 * Sample solution: Grasshopper
 * Author: Jan Stoklasa
 */

#include <iostream>
#include <queue>
#include <utility>
#include <limits>
 
using namespace std;
 
const int MAXM = 101; 	//1-based indexing
const int MAXN = 101;
int board[MAXM][MAXN];
int knight[8][2] = {{1,2},{1,-2},{-1,2},{-1,-2},{2,1},{2,-1},{-2,1},{-2,-1}};
 
void clearboard(int board[MAXM][MAXN], int M, int N)
{
	for (int i=0; i<=M; i++)
		for (int j=0; j<=N; j++)
		{
			board[i][j] = numeric_limits<int>::max();
		}
}
 
int main(int argc, char* argv[])
{	
	int M, N, X1, Y1, X2, Y2;
	while(cin >> M >> N >> X1 >> Y1 >> X2 >> Y2)
	{
		clearboard(board, M, N);
		queue<pair<int,int> > q;
		board[X1][Y1] = 0;
		q.push(make_pair(X1,Y1));
		while(!q.empty())
		{
			pair<int,int> p = q.front();
			q.pop();
			if (p.first == X2 && p.second == Y2)
			{
				cout << board[X2][Y2] << endl;
				goto next;
			}
			for (int i = 0; i < sizeof(knight)/sizeof(knight[0]); i++)
			{
				int x = p.first + knight[i][0]; 
				int y = p.second + knight[i][1];
				if (1 <= x && x <= M && 1 <= y && y <= N && 
					board[p.first][p.second] + 1 < board[x][y])
				{
					board[x][y] = board[p.first][p.second] + 1;
					q.push(make_pair(x,y));
				}
			}
		}
		cout << "impossible" << endl;
next:;
	}
	return 0;
}

